using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Reflection;
using System.Text;
using System.Windows.Forms;

using SharpFTPLibrary;

namespace SharpFTP
{
	public partial class FrmMain : Form
	{
	#region Variables
		private FtpClient ftp = new FtpClient ();

		private delegate void InsertText (string line, Color c);
		private InsertText addText;
	#endregion

// --------------------------------------------------------------------------- //

		public FrmMain ()
		{
			InitializeComponent ();

			addText = new InsertText (Insert);
			this.Text = Application.ProductName + " " + Assembly.GetCallingAssembly ().GetName ().Version.ToString ();
		}

// --------------------------------------------------------------------------- //

		private void Insert (string line, Color c)
		{
			rtbDebug.SelectionColor = c;
			rtbDebug.AppendText (line);
			rtbDebug.ScrollToCaret ();
			rtbDebug.SelectionColor = Color.Black;
		}

// --------------------------------------------------------------------------- //

		private void btnStart_Click (object sender, EventArgs e)
		{
			ftp.Name			= "Local";
			ftp.Host			= "127.0.0.1";
			ftp.Port			= 21;
			ftp.User			= "user";
			ftp.Pass			= "pass";
			ftp.SslType			= SslType.AuthSsl;
			ftp.ConnectionMode	= FtpConnectionMode.Active;
			ftp.ForcedActiveIP	= "127.0.0.1";

			ftp.Output				+= new FtpClient.FtpClientOutputEvent (ftp_Output);
			ftp.ResponseReceived	+= new FtpClient.FtpClientResponseReceivedEvent (ftp_ResponseReceived);
			ftp.LineSent			+= new FtpClient.FtpClientLineSentEvent (ftp_LineSent);
			ftp.LineRead			+= new FtpClient.FtpClientLineReadEvent (ftp_LineRead);

			//ftp.Host	= "127.0.0.1";
			//ftp.Port	= 21;
			//ftp.User	= "user";
			//ftp.Pass	= "pass";
			//ftp.IsSSL	= false;

			ftp.Connect ();
			ftp.ChangeCurrentDirectory ("proveftp");
			List<FTPFile> list = ftp.List ();

			ftp.ChangeCurrentDirectory ("delete");
			list = ftp.List ();

			//ftp.Delete ();
			ftp.CreateDirectory ("foo");
		}

// --------------------------------------------------------------------------- //

		void ftp_LineRead (object sender, FtpClient.FtpClientLineReadEventArgs e)
		{
			this.Invoke (addText, new Object[] { e.Line, Color.Green});
		}

// --------------------------------------------------------------------------- //

		void ftp_LineSent (object sender, FtpClient.FtpClientLineSentEventArgs e)
		{
			this.Invoke (addText, new Object[] { e.Line + "\r\n", Color.Black});
		}

// --------------------------------------------------------------------------- //

		void ftp_ResponseReceived (object sender, FtpClient.FtpClientResponseReceivedEventArgs e)
		{
			//this.Invoke (addText, new Object[] { e.Response.Message, Color.Green});
		}

// --------------------------------------------------------------------------- //

		void ftp_Output (object sender, FtpClient.FtpClientOutputEventArgs e)
		{
			this.Invoke (addText, new Object[] { e.Line, e.Color});
		}

// --------------------------------------------------------------------------- //

	}
}