using System;
using System.Collections.Generic;
using System.Text;

namespace SharpFTPLibrary
{
	public class FtpResponse
	{
	#region Properties
		private string message = "";
		public string Message
		{
			get
			{
				return message;
			}
			set
			{
				message			= value;
				code			= Convert.ToInt32 (message.Substring (0, 3));
				firstDigitGroup	= Convert.ToInt32 (message.Substring (0, 1));
				lines			= message.Split (new string[1] {"\r\n"}, StringSplitOptions.RemoveEmptyEntries);
			}
		}

// ------------------------------------------------------------------ //

		private int code = 0;
		public int Code
		{
			get
			{
				return code;
			}
		}

// ------------------------------------------------------------------ //

		private string[] lines = new string[1];
		public string[] Lines
		{
			get
			{
				return lines;
			}
			set
			{
				lines = value;
			}
		}

// ------------------------------------------------------------------ //

		//1xx
		//A "preliminary" reply: the server has not yet completed the command, another reply code should be expected. 
		//2xx
		//A "positive" reply: the command has been completed successfully. The most common version of this is simply "200". 
		//3xx
		//Not quite as "positive" as a 2xx reply. This indicates that some "intermediate" error has occurred, 
		//and that the user should revise the request and resend it. 
		//4xx
		//The request failed. This could be a simple reason like the file not being found. 
		//5xx
		//Permanent failure. A sever error occurred; this command will never succeed. 

		private int firstDigitGroup = 0;
		public int FirstDigitGroup
		{
			get
			{
				return firstDigitGroup;
			}
			set
			{
				firstDigitGroup = value;
			}
		}

// ------------------------------------------------------------------ //

	#endregion

// ------------------------------------------------------------------ //

	#region Constructors
		public FtpResponse ()
		{
			message = "";
			code	= -1;
		}

// ------------------------------------------------------------------ //

		public FtpResponse (string message)
		{
			this.Message = message;
		}

// ------------------------------------------------------------------ //
	#endregion

// --------------------------------------------------------------------------- //
	}
}
